# frozen_string_literal: true

require 'pronto'
require 'rspec'

module Pronto
  # Runner RSpec with pronto
  class Rspec < Runner
    def run
      files = ruby_patches.map(&:new_file_full_path)

      return [] unless files

      files.select { |file| valid_file?(file) }
           .map { |file| inspect_file(file) }
           .flatten.compact
    end

    def valid_file?(file)
      file.file? && file.basename.to_s.include?('spec.rb')
    end

    def inspect_file(file)
      exec("rspec #{file}")
    end
  end
end
